--Script by Starkkz
--Edited a bit by Useigor

hudmp5g_chi = {};	for i = 1,32 do hudmp5g_chi[i] = {} end
hudmp5g_zna = {};	for i = 1,32 do hudmp5g_zna[i] = {} end

grenade_hud = 1
hudmp5g = {}

function hl2df_die_hud_mp5g(id)
	svobraz(id, hudmp5g_chi, hudmp5g_zna)	-- MP5 greandes HUD will be removed after death
end

function update_grenade_hud(id)
	if player(id,"weapontype") == 22 then
		svobraz(id, hudmp5g_chi, hudmp5g_zna)
		obraz(id, hudmp5g_zna, "ammo_grenade", hud_a2i_x, hud_y2, hud_it, hud_a2i_xs, hud_a2i_ys, hudmp5g, hudmp5g_chi, hud_a2_x, hud_d_x, hud_a2_xs, hud_a2_ys)
	else
		svobraz(id, hudmp5g_chi, hudmp5g_zna)
	end
end


function hl2df_spawn_mp5g(id)
     hudmp5g[id] = 0
     update_grenade_hud(id)
end

function mp5gren_collect(id,iid,t,ammoin,a,m)
     if t == 22 then
          hudmp5g[id] = hudmp5g[id] + 5
          if hudmp5g[id] > 10 then hudmp5g[id] = 10 end
          update_grenade_hud(id)
     end
end

function hl2df_select_mp5(id,t,m)
     update_grenade_hud(id)
end

function CreateMp5Gren(x,y,rot,speed,radius,pl)
     local img = image("gfx/hl2d/weapons/p90_grenade.bmp<m>", 0, 0, 1)
	 local x = x + math.sin(math.rad(rot)) * 16
	 local y = y - math.cos(math.rad(rot)) * 16
     imagepos(img, x, y, rot)
     table.insert(mp5grenlist, {img,rot,speed,radius,0,pl})
end

mp5grenlist = {}
function hl2df_always_mp5g()
	for k, g in pairs(mp5grenlist) do
		local Angle = math.rad(g[2])
		local x = object(g[1], "x") + math.sin(Angle) * g[3]
		local y = object(g[1], "y") - math.cos(Angle) * g[3]
		g[5] = g[5] + g[3]
		local pcollide
		for _,eid in pairs(player(0,"tableliving")) do
			if eid ~= id and math.abs(x-player(eid,"x"))+math.abs(y-player(eid,"y")) < 20 then
				pcollide = true
			end
		end
		if tile(math.floor(x/32), math.floor(y/32), "wall") or g[5] >= g[4] or pcollide then
			parse("explosion "..object(g[1], "x").." "..object(g[1], "y").." 100 100 "..(g[6] or 0))
			mp5grenlist[k] = nil
			freeimage(g[1])
		else
			imagepos(g[1], x, y, g[2])
		end
	end
end

function hl2df_mp5_addgrenade(id,iid,type)
	if type == 22 then
		hudmp5g[id] = hudmp5g[id] + 5
		if hudmp5g[id] > 10 then hudmp5g[id] = 10 end
		update_grenade_hud(id)
	end
end