wpn = {}
img = {}
spd = {}

img.snark = {}			--  ,  
wpn.snark = {} 			-- -   
img_num_snark = mnja(32)	-- images of numbers for ammo
img_ico_snark = mnja(32)	-- images of snark icon
dist = 10		-- max distance 10 tiles
spd.snark = 6 	-- snark speed 6 tile/sec

function pv(a,b)
	return (a*1000)/(spd[b]*32)
end

function update_hud_snark(id)
	if player(id,"weapontype") == 5 then
		svobraz(id, img_num_snark, img_ico_snark)
		obraz(id, img_ico_snark, "ammo_snark", hud_a2i_x, hud_y2, hud_it, hud_a2i_xs, hud_a2i_ys, wpn.snark, img_num_snark, hud_a2_x, hud_d_x, hud_a2_xs, hud_a2_ys)
	else
		svobraz(id, img_num_snark, img_ico_snark)
	end
end

function hl2df_spawn_snark(id)
	wpn.snark[id] = 0
end

function hl2df_select_snark(id)
	update_hud_snark(id)
end

function hl2df_wo_snark(id,iid,type)
	if type == 5 then
		local bp
		if igkorb[iid] then	--   
			if igkorb[iid].snark then	--    - ""
				bp = igkorb[iid].snark	-- 
				igkorb[iid].snark = nil	--     ,    , ..     
			else	--   
				bp = 5
			end
		else	--   
			bp = 5
		end
		if wpn.snark[id] + bp > 15 then	--  ,  15 
			wpn.snark[id] = 15
		else
			wpn.snark[id] = wpn.snark[id] + bp
		end
		update_hud_snark(id)	--  (image)  ; ""       "" ( -)
	end
end

function hl2df_attack_snark(id)
	local px,py,pr,wx,wy = player(id,"x"),player(id,"y"),player(id,"rot"); local r = math.rad(pr-90)
	if player(id,"weapontype") == 5 then
		if wpn.snark[id] > 0 then
			wpn.snark[id] = wpn.snark[id] - 1
			if wpn.snark[id] <= 0 then parse("strip "..id.." 5") end
			update_hud_snark(id)
			for i = 0,dist*32,16 do
				local x = math.floor((px+math.cos(r)*i)/32)	--    x,   
				local y = math.floor((py+math.sin(r)*i)/32)	--  y
				if tile(x,y,"walkable") == true then wx = x; wy = y end	--  ,    
				if tile(x,y,"wall") == true then i = dist*32 end	--  ,   
				if i == dist*32 then
					x,y = wx*32+16, wy*32+16	--  
					local z = math.sqrt((x-px)^2 + (y-py)^2)	--    
				--
					img.snark[id] = image("gfx/npc/snark.bmp<m>",0,0,1)		--  
					imagepos(img.snark[id],(px+math.cos(r)*16),(py+math.sin(r)*16),pr-180)	--   
					tween_move(img.snark[id],pv(z,"snark"),x,y,pr)	--  
					timer(pv(z,"snark"),"freeimage",img.snark[id])	--    
					timer(pv(z,"snark"),"parse",'spawnnpc 3 '..wx..' '..wy..' '..pr)	--     
					break
				end
			end
		else
			parse("strip "..id.." 5")	--  ,    (0)
		end
	end
end

function hl2df_die_snark(id,iid,type)
	if type == 5 then
		igkorb[iid]["snark"] = wpn.snark[id]	-- 
		wpn.snark[id] = 0	-- 
		update_hud_snark(id)
	end
end