-- Script by Starkkz and Useigor
igrach_skrast = {};			for i = 1,32 do igrach_skrast[i] = 0 end
igrach_skrast_prmn = {};	for i = 1,32 do igrach_skrast_prmn[i] = 0 end

-- Convert weapon speed modifier(WSM) to speedmodvalue(SMV)
function s(s)
	return 10*(1.2 - s)
end

-- Table of speed depending the id of the weapon
listspeed = {}
weaponspeed = {}

-- WSM of weapon(s) coverts to speed 6 tiles/sec
listspeed[s(-0.50)] = {35,36,40}				-- AWP | G3SG1 | M249
listspeed[s(-0.30)] = {45}						-- Laser
listspeed[s(-0.20)] = {85}						-- Chainsaw
listspeed[s(-0.10)] = {46,47,49}				-- Flamethrower | RPG | Grenade Launcher
listspeed[s(0.00)]  = {11,22,24}				-- XM1014 | P90 | UMP45
listspeed[s(0.10)]  = {34}						-- Scout
listspeed[s(0.50)]  = {2,3,4,5,51,69,75,87,89}	-- Glock | Deagle | P228 | Elite | HE | Machete | Snowball | Laser Mine | Satchel
listspeed[s(0.75)]  = {50,74}					-- Knife | Wrench

function InitSpeed()
     for speed, weapons in pairs(listspeed) do
          for _, id in pairs(weapons) do
               weaponspeed[id] = speed
          end
     end
end; InitSpeed()

function hl2df_player_speed(id)
     local wpn = player(id,"weapontype")
	 local prmn = igrach_skrast_prmn[id]
	 local wpnid; if weaponspeed[wpn] ~= nil then wpnid = weaponspeed[wpn] else wpnid = 0 end	-- for case if weapon not from the tables
	 local znama; if player(id,"flag") == true then znama = 0.5 else znama = 0 end

     -- Check if this weapon exists
	 local znach = wpnid + znama + prmn
     if igrach_skrast[id] ~= znach then
          -- Set the weapon's speed
		  igrach_skrast[id] = (wpnid + znama + prmn)
          parse("speedmod "..id.." "..wpnid+znama+prmn)
     end
end