--Script by Starkkz

PlayerMovePlace = {}
igracz_zapryg = {}

function Millisecs()
	return os.clock() * 1000
end

function move_player(id,delay,x,y)
	PlayerMovePlace[id] = {
		x = x,
		y = y,
		start = Millisecs(),
		finish = Millisecs() + delay,
		delay = delay,
		startx = player(id,"x"),
		starty = player(id,"y"),
	}
end

function PlayerSetpos()
	for id, m in pairs(PlayerMovePlace) do
		if player(id, "exists") and player(id, "health") > 0 and m.finish - Millisecs() > 0 then
			local percent = (m.finish - Millisecs())/m.delay
			local Dist = math.sqrt((m.startx-m.x)^2 + (m.starty - m.y)^2)* (1 - percent)
			local Angle = math.atan2(m.starty-m.y,m.startx-m.x) - math.pi/2
			if Angle < -math.pi then Angle = Angle + math.pi*2 end

			local x = m.startx + math.sin(Angle) * Dist
			local y = m.starty - math.cos(Angle) * Dist

			if x > 0 and y > 0 and x < (map("xsize")+1)*32 and y < (map("ysize")+1)*32 then
				parse("setpos "..id.." "..x.." "..y)
			end

			if Dist == 0 then PlayerMovePlace[id] = nil end
		else
			PlayerMovePlace[id] = nil
		end
	end
end

function freeline(fx,fy,tx,ty)
	local a = math.atan2(fy-ty,fx-tx) - math.pi/2
	local dist = math.sqrt((fx-tx)^2 + (fy-ty)^2)

	if a < -math.pi then a = a + math.pi*2 end
	for i = 0, dist, 8 do
		local x = fx + math.sin(a) * i
		local y = fy - math.cos(a) * i
		if not tile(math.floor(x/32), math.floor(y/32), "walkable") then
			return false, i
		end
	end
	return true, dist
end

jump_delay = 1 -- 1 second
jump_dist = 240 -- 240 pixels
player_lastjump = {}
function player_longjump(id)
	if player(id,"health") > 0 then
		if not player_lastjump[id] or os.clock() - player_lastjump[id] >= jump_delay then
			local rot = math.rad(player(id,"rot"))
			local x = player(id,"x") + math.sin(rot) * jump_dist
			local y = player(id,"y") - math.cos(rot) * jump_dist
			local free, dist = freeline(player(id,"x"), player(id,"y"), x, y)

			if dist < jump_dist then
				x = player(id,"x") + math.sin(rot) * dist
				y = player(id,"y") - math.cos(rot) * dist
			end

			if dist > 0 then
				player_lastjump[id] = os.clock()
				move_player(id, dist/jump_dist * 500, x, y)
			end
		end
	end
end

function hl2df_die_lj(id)
	if igracz_zapryg[id] ~= nil then
		freeimage(igracz_zapryg[id])
		igracz_zapryg[id] = nil
	end
end