-- HUD
	set_hud_item= 1		-- images of collected weapons [disable(0)/enable(1)]
	hud_d_x		= 18	-- distance between numbers
	hud_y1		= 457	-- height line 1 (HP,AP)
	hud_y2		= 429	-- height line 2 (ammo 2)
	hud_y3		= 32	-- height line 3 (charge)
	hud_it		= 2		-- image type
	hud_blend	= 1
	hud_alpha	= 0.375
	
---- Health Points
	igzd 		= 100	-- player HP. You can more try more than 100. ;)
	nigzd		= 100	-- max HP for custom HP.
	pred_leka	= 15	-- points of item "medkit"
	---- Icon
		hud_hpi_x	= 32	-- position x
		hud_hpi_xs	= 1		-- scale x
		hud_hpi_ys	= 1		-- scale y
	---- Numbers
		hud_hp_x	= 93	-- position x
		hud_hp_xs	= 1		-- scale x
		hud_hp_ys	= 1		-- scale y
		
---- Palka
		hud_pi_x	= 113	-- position x
		hud_pi_xs	= 1		-- scale x
		hud_pi_ys	= 1		-- scale y
		
---- Doska
		hud_di_x	= 135	-- position x
		hud_di_xs	= 1		-- scale x
		hud_di_ys	= 1		-- scale y

---- Armour Points
	igbr 		= 0		-- player AP.
	nigbr		= 100	-- max AP for custom AP.
	pred_ohra	= 15	-- points of item "battery"
	---- Icon
		hud_api_x	= 153	-- position x
		hud_api_xs	= 1		-- scale x
		hud_api_ys	= 1		-- scale y
	---- Numbers
		hud_ap_x	= 219	-- position x
		hud_ap_xs	= 1		-- scale x
		hud_ap_ys	= 1		-- scale y
		
---- Attaque 2
	---- Icon
		hud_a2i_x	= 610	-- position x
		hud_a2i_xs	= 1		-- scale x
		hud_a2i_ys	= 1		-- scale y
	---- Numbers
		hud_a2_x	= 585	-- position x
		hud_a2_xs	= 1		-- scale x
		hud_a2_ys	= 1		-- scale y

---- Colours
	---- Opposing Force
		zoR	= 0
		zoG	= 160
		zoB	= 0
	---- Gordon & Scientist
		zaR	= 255
		zaG	= 160
		zaB	= 0
	---- Gina
		zbR	= 255
		zbG	= 255
		zbB	= 255
	---- Barney
		zcR	= 128
		zcG	= 160
		zcB	= 255
	---- VIP
		ztR	= 255
		ztG	= 255
		ztB	= 255

hl2d_mp_buymenu	= "0|0|0|0|0|0"	-- no weapons in buymenu
hl2d_mp_buytime	= 0				-- set buytime to 0 sec
hl2d_drawradar	= 0				-- hide radar
hl2d_mp_radar	= 0				-- disable radar
hl2d_mp_hud 	= 108			-- display some HUD parts

function hl2df_nobuying()
	return 1
end

--Weapons by which player will be equiped/stripped on spawn
function hl2df_spawn(id)
	igracz_zapryg[id] = nil
	parse("equip ".. id .." 2")
	parse("equip ".. id .." 69")
	parse("strip ".. id .." 1")
	parse("strip ".. id .." 50")
end

function hl2df_collect_wpns(id,iid,type,ain,a,mode)
	if itemtype(type,"recoil") > 0 or type == 46 then
		hl2d_sbora(id,type)
		parse("equip "..id.." "..type)
		parse("setweapon "..id.." "..type)
		parse("removeitem "..iid)
	end
end

igkorb = {}		-- iid
--Weapons which will be stripped after death therefore you one will see them
function hl2df_die(id)
	parse("strip ".. id .." 69")
	parse("strip ".. id .." 2")
	local wid
	for n,type in pairs(playerweapons(id)) do
		if type ~= 50 then
			if n == 1 then
				local px,py = player(id,"tilex"),player(id,"tiley")
				parse("spawnitem 90 "..px.." "..py)
				for _,iid in pairs(item(0,"table")) do
					if item(iid,"x") == px then
						if item(iid,"y") == py then
							if item(iid,"type") == 90 then
								if item(iid,"droptimer") < 1 then
									wid = iid
									igkorb[wid] = {}
									igkorb[wid]["igor"] = playerweapons(id)
								end
							end
						end
					end
				end
			end
			hl2df_die_snark(id,wid,type)
		end
	end
end

parse("mp_hud "..hl2d_mp_buymenu)
parse("mp_hud "..hl2d_mp_buytime)
parse("mp_hud "..hl2d_drawradar)
parse("mp_hud "..hl2d_mp_radar)
parse("mp_hud "..hl2d_mp_hud)

addhook("startround","hl2d_sr")
function hl2d_sr(mode)	-- if something changed in server settings then
	if game("mp_buymenu") ~= tostring(hl2d_mp_buymenu) then parse("mp_buymenu "..hl2d_mp_buymenu) end
	if game("mp_buytime") ~= tostring(hl2d_mp_buytime) then parse("mp_buytime "..hl2d_mp_buytime) end
	if game("drawradar") ~= tostring(hl2d_drawradar) then parse("drawradar "..hl2d_drawradar) end
	if game("mp_radar") ~= tostring(hl2d_mp_radar) then parse("mp_radar "..hl2d_mp_radar) end
	if game("mp_hud") ~= tostring(hl2d_mp_hud) then parse("mp_hud "..hl2d_mp_hud) end
end

addhook("drop","hl2d_drop")
function hl2d_drop()
	return 1
end